#
# pushare - P2P file sharing system
#
# (c) FukTommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: $
#

package Pushare::Util;
use Pushare::Config;

#
# configuration
#
$lock = $Pushare::Config::lock;
$PI   = 3.1415926535;

sub lock(;$) {
	if ($^O ne "cygwin") {
		open LOCK, "> $lock" or die "$lock: open failed. $!";
		flock LOCK, 002;
	}
}

sub unlock() {
	if ($^O ne "cygwin") {
		close LOCK;
	}
}

sub addDist($$) {
	my($stamp, $id) = @_;
	my $distlist = $Pushare::Config::distlist;
	my $savedist = $Pushare::Config::savedist;
	my @dist = ();
	if (open IN, $distlist) {
		@dist = <IN>;
		close IN;
	}
	push @dist, "$stamp<>$id\n";
	local $_;
	lock();
	open OUT, "> $distlist" or die "$distlist: failed to open. $!";
	foreach (@dist) {
		local @_ = split /<>/, $_;
		if ($stamp - $_[0] <= $savedist * 60) {
			print OUT;
		}
	}
	close OUT;
	unlock();
}

sub delDist($$) {
	my($stamp, $id) = @_;
	my $distlist  = $Pushare::Config::distlist;
	my @dist = ();
	if (open IN, $distlist) {
		@dist = <IN>;
		close IN;
	}
	lock();
	open OUT, "> $distlist" or die "$distlist: failed to open. $!";
	foreach (@dist) {
		print OUT if ($_ ne "$stamp<>$id\n");
	}
	close OUT;
	unlock();
}

sub addIgnore($) {
	my($id) = @_;
	my $ignorelist = $Pushare::Config::ignorelist;
	lock();
	open OUT, ">> $ignorelist" or die "$ignorelist: failed to open. $!";
	print OUT "$id\n";
	close OUT;
	unlock();
}

#
# nomal random (Box-Muller)
#
sub normal() {
	my($r1, $r2) = (rand, rand);
	return sqrt(-2 * log($r1)) * sin(2 * $PI * $r2);
}

1;
